<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_91) on Fri Dec 07 15:00:35 GMT 2018 -->
<title>TreeDataStructure</title>
<meta name="date" content="2018-12-07">
<link rel="stylesheet" type="text/css" href="../stylesheet.css" title="Style">
<script type="text/javascript" src="../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="TreeDataStructure";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../mapping/package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/TreeDataStructure.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../deprecated-list.html">Deprecated</a></li>
<li><a href="../index-files/index-1.html">Index</a></li>
<li><a href="../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../mapping/Presenter.html" title="class in mapping"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../mapping/TreeNode.html" title="class in mapping"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../index.html?mapping/TreeDataStructure.html" target="_top">Frames</a></li>
<li><a href="TreeDataStructure.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">mapping</div>
<h2 title="Class TreeDataStructure" class="title">Class TreeDataStructure&lt;T extends java.lang.Comparable&lt;T&gt;&gt;</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>mapping.TreeDataStructure&lt;T&gt;</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the data type to be contained in the tree</dd>
</dl>
<dl>
<dt>All Implemented Interfaces:</dt>
<dd>java.lang.Iterable&lt;T&gt;</dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">TreeDataStructure&lt;T extends java.lang.Comparable&lt;T&gt;&gt;</span>
extends java.lang.Object
implements java.lang.Iterable&lt;T&gt;</pre>
<div class="block">Class to model a k-ary tree. This is a tree data structure where each node 
 can have multiple children. It was created to model the structure that the 
 keymaps will take within the XML file. The tree implements a breadth first 
 iterator.</div>
<dl>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Matthew Henderson - University of Glasgow Masters Project 2018</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../mapping/TreeDataStructure.html#TreeDataStructure--">TreeDataStructure</a></span>()</code>
<div class="block">Constructs the TreeDataStructure object.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../mapping/TreeDataStructure.html#add-T-T-">add</a></span>(<a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a>&nbsp;element,
   <a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a>&nbsp;parent)</code>
<div class="block">Adds an element to the tree.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../mapping/TreeDataStructure.html#contains-T-">contains</a></span>(<a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a>&nbsp;element)</code>
<div class="block">Returns whether an element is in the tree.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code><a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../mapping/TreeDataStructure.html#getParent-T-">getParent</a></span>(<a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a>&nbsp;element)</code>
<div class="block">Returns the parent of the element in the tree.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../mapping/TreeDataStructure.html#isEmpty--">isEmpty</a></span>()</code>
<div class="block">Returns whether the tree is empty, the root node is ignored.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>java.util.Iterator&lt;<a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../mapping/TreeDataStructure.html#iterator--">iterator</a></span>()</code>
<div class="block">Returns a breadth-first iterator.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../mapping/TreeDataStructure.html#remove-T-">remove</a></span>(<a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a>&nbsp;element)</code>
<div class="block">Removes an element from the tree.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Iterable">
<!--   -->
</a>
<h3>Methods inherited from interface&nbsp;java.lang.Iterable</h3>
<code>forEach, spliterator</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="TreeDataStructure--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>TreeDataStructure</h4>
<pre>public&nbsp;TreeDataStructure()</pre>
<div class="block">Constructs the TreeDataStructure object. 
 Places an empty node at the root of the tree. This allows multiple KeyMap to 
 be at the top level of the hierarchy (the empty root node is ignored and its 
 children are considered the top of the tree).</div>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="isEmpty--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isEmpty</h4>
<pre>public&nbsp;boolean&nbsp;isEmpty()</pre>
<div class="block">Returns whether the tree is empty, the root node is ignored.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>returns <code>true</code> if the tree is empty,  
                        <code>false</code> otherwise</dd>
</dl>
</li>
</ul>
<a name="remove-java.lang.Comparable-">
<!--   -->
</a><a name="remove-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>remove</h4>
<pre>public&nbsp;boolean&nbsp;remove(<a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a>&nbsp;element)</pre>
<div class="block">Removes an element from the tree.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>element</code> - the element to be removed</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>returns <code>true</code> if the elements has been   
                                        successfully removed, <code>false</code> otherwise</dd>
</dl>
</li>
</ul>
<a name="contains-java.lang.Comparable-">
<!--   -->
</a><a name="contains-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>contains</h4>
<pre>public&nbsp;boolean&nbsp;contains(<a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a>&nbsp;element)</pre>
<div class="block">Returns whether an element is in the tree.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>element</code> - the element to be checked for</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>returns <code>true</code> if the element is in the   
                                        tree, <code>false</code> otherwise</dd>
</dl>
</li>
</ul>
<a name="add-java.lang.Comparable-java.lang.Comparable-">
<!--   -->
</a><a name="add-T-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>add</h4>
<pre>public&nbsp;boolean&nbsp;add(<a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a>&nbsp;element,
                   <a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a>&nbsp;parent)</pre>
<div class="block">Adds an element to the tree.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>element</code> - the element to be added</dd>
<dd><code>parent</code> - the parent of the element to be added</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>returns <code>true</code> if the element has been added to the  
                                        tree, <code>false</code> otherwise</dd>
</dl>
</li>
</ul>
<a name="getParent-java.lang.Comparable-">
<!--   -->
</a><a name="getParent-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getParent</h4>
<pre>public&nbsp;<a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a>&nbsp;getParent(<a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a>&nbsp;element)</pre>
<div class="block">Returns the parent of the element in the tree.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>element</code> - the element thats parent will be retrieved</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the parent of the element</dd>
</dl>
</li>
</ul>
<a name="iterator--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>iterator</h4>
<pre>public&nbsp;java.util.Iterator&lt;<a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a>&gt;&nbsp;iterator()</pre>
<div class="block">Returns a breadth-first iterator.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code>iterator</code>&nbsp;in interface&nbsp;<code>java.lang.Iterable&lt;<a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a> extends java.lang.Comparable&lt;<a href="../mapping/TreeDataStructure.html" title="type parameter in TreeDataStructure">T</a>&gt;&gt;</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the iterator</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../mapping/package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/TreeDataStructure.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../deprecated-list.html">Deprecated</a></li>
<li><a href="../index-files/index-1.html">Index</a></li>
<li><a href="../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../mapping/Presenter.html" title="class in mapping"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../mapping/TreeNode.html" title="class in mapping"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../index.html?mapping/TreeDataStructure.html" target="_top">Frames</a></li>
<li><a href="TreeDataStructure.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
